${view.codeName}ControllerBase.prototype.getNewDataView = function(params) {
    if (!params) {
        params = {};
    }
    var newmode = params.srfnewmode;
    if (!newmode) {
        newmode='';
    }
    <#list view.getAppViewRefModes() as viewref>
    <#if (viewref?index_of("NEWDATA:")==0)>
    <#assign newdataview=view.getRefPSAppView(viewref,true) >
    <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
    if (newmode=='${viewref?substring(8)}') {
        <#if (newdataviewref.getViewParam()??)>
        Object.assign(params, ${newdataviewref.getViewParam()});
        </#if>
        return {  
            title: '${newdataview.getTitle(newdataviewref)}',
            openMode:'${newdataview.getOpenMode(newdataviewref)}',
            height: ${newdataview.getHeight(newdataviewref)?c},
            width: ${newdataview.getWidth(newdataviewref)?c},
            layout: 'fit',  
            maximizable: true,  
            routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
            viewname: '${filename('${newdataview.codeName}')}',
            modalviewname: '${filename('${newdataview.codeName}')}_modalview',
            viewurl: '/pages/${filename('${newdataview.getPSAppModule().codeName}')}/${filename('${newdataview.codeName}')}/${filename('${newdataview.codeName}')}.html#/${filename('${newdataview.codeName}')}',
            viewparam: params 
        };
	}
    </#if>
    </#list>

    var parts = newmode.split('@');
    if (parts.length == 2) {
    <#list view.getAppViewRefModes() as viewref>
    <#if (viewref?index_of("NEWDATA@")==0)>      
    <#assign newdataview=view.getRefPSAppView(viewref,true) >
    <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
		if(parts[1]=='${viewref?substring(8)}'){
            <#if (newdataviewref.getViewParam()??)>
            Object.assign(params, ${newdataviewref.getViewParam()});
            </#if>
            return {  
                title: '${newdataview.getTitle(newdataviewref)}',
                openMode:'${newdataview.getOpenMode(newdataviewref)}',
                height: ${newdataview.getHeight(newdataviewref)?c},
                width: ${newdataview.getWidth(newdataviewref)?c},
                layout: 'fit',  
                maximizable: true,  
                routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
                viewname: '${filename('${newdataview.codeName}')}',
                modalviewname: '${filename('${newdataview.codeName}')}_modalview',
                viewurl: '/pages/${filename('${newdataview.getPSAppModule().codeName}')}/${filename('${newdataview.codeName}')}/${filename('${newdataview.codeName}')}.html#/${filename('${newdataview.codeName}')}',
                viewparam: params 
            };
		}
    </#if>
    </#list>
    }
    
    <#list view.getAppViewRefModes() as viewref>
    <#if (viewref == "NEWDATA")>      
    <#assign newdataview=view.getRefPSAppView(viewref,true) >
    <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
    <#if (newdataviewref.getViewParam()??)>
    Object.assign(params, ${newdataviewref.getViewParam()});
    </#if>
    return {  
        title: '${newdataview.getTitle(newdataviewref)}',
        openMode:'${newdataview.getOpenMode(newdataviewref)}',
        height: ${newdataview.getHeight(newdataviewref)?c},
        width: ${newdataview.getWidth(newdataviewref)?c},
        layout: 'fit',  
        maximizable: true,  
        routepath: '${newdataview.getPSAppModule().codeName?lower_case}_${newdataview.codeName?lower_case}',
        viewname: '${filename('${newdataview.codeName}')}',
        modalviewname: '${filename('${newdataview.codeName}')}_modalview',
        viewurl: '/pages/${filename('${newdataview.getPSAppModule().codeName}')}/${filename('${newdataview.codeName}')}/${filename('${newdataview.codeName}')}.html#/${filename('${newdataview.codeName}')}',
        viewparam: params 
    };
    </#if>
    </#list>
}

${view.codeName}ControllerBase.prototype.getEditDataView = function(params){
    var editmode = params.srfkey;
    if(!editmode) {
        editmode='';
    }
    var parts = editmode.split(';');
    if (parts.length != 2) {
        return null;
    }
         
    <#list view.getAppViewRefModes() as viewref>
    <#if (viewref?index_of("EDITDATA@")==0)>
    <#assign editdataview=view.getRefPSAppView(viewref,true) >
    <#assign editdataviewref=view.getPSAppViewRef(viewref,true) >
    if (parts[0] == '${viewref?substring(9)}') {
        <#if (editdataviewref.getViewParam()??)>
        Object.assign(params, ${editdataviewref.getViewParam()});
        </#if>
        params.srfkey = parts[1];
        return {  
            title: '${editdataview.getTitle(editdataviewref)}',
            openMode:'${editdataview.getOpenMode(editdataviewref)}',
            height: ${editdataview.getHeight(editdataviewref)?c},
            width: ${editdataview.getWidth(editdataviewref)?c},
            layout: 'fit',  
            maximizable: true,  
            routepath: '${editdataview.getPSAppModule().codeName?lower_case}_${editdataview.codeName?lower_case}',
            viewname: '${filename('${editdataview.codeName}')}',
            modalviewname: '${filename('${editdataview.codeName}')}_modalview',
            viewurl: '/pages/${filename('${editdataview.getPSAppModule().codeName}')}/${filename('${editdataview.codeName}')}/${filename('${editdataview.codeName}')}.html#/${filename('${editdataview.codeName}')}',
            viewparam: params 
        };
    }
    </#if>
    </#list>
    return null;
}
<#if view.getRefPSAppView("NEWDATAWIZARD",true)??>

<#assign newdatawizardview=view.getRefPSAppView("NEWDATAWIZARD",true) >
<#assign newdatawizardviewref=view.getPSAppViewRef("NEWDATAWIZARD",true) >
${view.codeName}ControllerBase.prototype.getNewDataWizardView = function(params){
    if (!params) {
        params={};
    }
    return {  
        title: '${newdatawizardview.getTitle(newdatawizardviewref)}',
        openMode:'${newdatawizardview.getOpenMode(newdatawizardviewref)}',
        height: ${newdatawizardview.getHeight(newdatawizardviewref)?c},
        width: ${newdatawizardview.getWidth(newdatawizardviewref)?c},
        layout: 'fit',  
        maximizable: true,  
        routepath: '${newdatawizardview.getPSAppModule().codeName?lower_case}_${newdatawizardview.codeName?lower_case}',
        viewname: '${filename('${newdatawizardview.codeName}')}',
        modalviewname: '${filename('${newdatawizardview.codeName}')}_modalview',
        viewurl: '/pages/${filename('${newdatawizardview.getPSAppModule().codeName}')}/${filename('${newdatawizardview.codeName}')}/${filename('${newdatawizardview.codeName}')}.html#/${filename('${newdatawizardview.codeName}')}',
        viewparam: params 
    };
}
</#if>