<#comment><!--开始：代码表--></#comment>
    <#if (view.getRelatedPSCodeList(false)?? && iteratorlength(view.getRelatedPSCodeList(false)) gt 0)>

    /**
     * 注册视图代码表（静态）
     *
     * @param {*} [opts={}]
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.regCodeLists = function (opts) {
        if (opts === void 0) { opts = {}; }
        <#list view.getRelatedPSCodeList(false) as codelist>
        <#if codelist.getCodeListType()=='STATIC'>
        // ${codelist.name}
        this.regCodeList(new IBizCodeList({ id: '${srfparamname('${sys.codeName}')}_${codelist.codeName}', datas: [<#if codelist.getPSCodeItems()??><#list codelist.getPSCodeItems() as codeitem><#if (codeitem_index>0)>,</#if>{ text: '${codeitem.text}', value: '${codeitem.value}', realtext: '${codeitem.realText}'<#if codeitem.getParentValue()??>, parentvalue='${codeitem.getParentValue()}'</#if><#if codeitem.getColor()??>, color: '${codeitem.getColor()}'</#if><#if codeitem.getTextCls()??>, textcls: '${codeitem.getTextCls()}'</#if><#if codeitem.getIconCls()??>, iconcls: '${codeitem.getIconCls()}'</#if>}</#list></#if>]}));
        </#if>
        </#list>
    };
    </#if>
    <#comment><!--结束：代码表--></#comment>
    <#comment><!--开始：计数器--></#comment>
    <#if (view.getPSSysCounterRefs()?? && iteratorlength(view.getPSSysCounterRefs()) gt 0)>

    /**
     * 注册视图计数器
     *
     * @param {*} [opts={}]
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.regUICounters = function (opts) {
        if (opts === void 0) { opts = {}; }
        <#list view.getPSSysCounterRefs() as syscounterref>
        <#assign syscounter = syscounterref.getPSSysCounter()>
        // ${syscounter.name}
        const ${syscounter.getCodeName()} = new IBizUICounter({
            name: '${syscounter.getCodeName()}',
            counterId: '${syscounter.id}',
            tag: '${syscounterref.tag}',
            counterParam: ${syscounterref.getRefMode().toString()},
            timer: ${syscounter.timer?c},
            viewController: this,
            url: this.getBackendUrl(),
        });
        this.uicounters.set('${syscounter.getCodeName()}', ${syscounter.getCodeName()});
        </#list>
    };
    </#if>

    <#comment><!--结束：计数器--></#comment>
    <#comment><!--开始：自由布局--></#comment>
    <#if view.getPSSysViewLayoutPanel()??>
    /**
     * 是否自由布局
     *
     * @returns {boolean}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isFreeLayout = function () {
        return true;
    };

    </#if>
    <#comment><!--结束：自由布局--></#comment>
    /**
     * 注册视图刷新面板
     *
     * @param {*} [opts={}]
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.regUpdatePanels = function (opts) {
        if (opts === void 0) { opts = {}; }
    };

    /**
     * 获取实体名称
     * 
     * @returns {string} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getDEName = function() {
        return '<#if view.isPSDEView()><#if view.getPSDataEntity()??>${view.getPSDataEntity().getName()}</#if></#if>';
    }

    return ${view.codeName}ControllerBase;
    
}(${viewContorllerName}));
<#comment><!--开始：以下为多数据内容--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--开始：自由布局--></#comment>
<#comment><!--结束：以下为多数据内容--></#comment>