<#comment><!--开始：实体部件逻辑处理--></#comment>
    <#if view.getPSDataEntity()??>
    <#assign de=view.getPSDataEntity()>
    <#if view.hasPSControl('form')>
    <#assign form = view.getPSControl('form')>

    /**
     * 表单项值变化事件
     * 
     * @param {string} fieldname 
     * @param {*} value 
     * @param {*} [field={}] 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.onFormFieldChanged = function(fieldname, field, value) {
        var form = this.getForm();
        <#list form_fdlogics as fdlogic>
        ${fdlogic}
        </#list>

        <#if form.getPSDEFormItems()??>
        <#list form.getPSDEFormItems() as formitem>
        <#if formitem.getPSDEFormItemUpdate()??>
        if(Object.is(fieldname, '${formitem.name}')){
            form.updateFormItems('${formitem.getPSDEFormItemUpdate().codeName}');
        }
        </#if>
        </#list>
        </#if>
    }

    /**
     * 表单项值检测
     *
     * @param {string} fieldname
     * @param {string} value
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.onFormFieldValueCheck = function(name, value) {
        var form = this.getForm();
        <#list form_vrlogics as vrlogic>
        
        ${vrlogic}
        </#list>
    }
    <#comment><!--开始：设置自动选择（ac）编辑器选择、显示内容--></#comment>

    /**
     * 绘制选择编辑器ac选择内容
     *
     * @param {string} name
     * @param {*} [item={}]
     * @returns {string}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.rendererRefAcOption = function(name, item) {
        <#if form.getPSDEFormItems()??>
        <#list form.getPSDEFormItems() as formitem>
        <#if formitem.getRefPSDEACMode()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,form,column) != "">
        if (Object.is(name, '${formitem.name}')) {
            return ${formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE2",pf.getId(),pfstyle.getId(),view,form,column)};
        }
        </#if>
        </#if>
        </#if>
        </#list>
        </#if>
        return item.text;
    }

    /**
     * 绘制选择编辑器ac显示内容
     *
     * @param {string} name
     * @param {*} [item={}]
     * @returns {string}
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.rendererRefAcText = function(name, item) {
        <#if form.getPSDEFormItems()??>
        <#list form.getPSDEFormItems() as formitem>
        <#if formitem.getRefPSDEACMode()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin()??>
        <#if formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE",pf.getId(),pfstyle.getId(),view,form,column) != "">
        if (Object.is(name, '${formitem.name}')) {
            return ${formitem.getRefPSDEACMode().getItemsPSSysPFPlugin().getCode("CODE",pf.getId(),pfstyle.getId(),view,form,column)};
        }
        </#if>
        </#if>
        </#if>
        </#list>
        </#if>
        return item.text;
    }
    <#comment><!--结束：设置自动选择（ac）编辑器选择、显示内容--></#comment>
    </#if>
    </#if>
    <#comment><!--结束：实体部件逻辑处理--></#comment>
    <#comment><!--开始：是否启用新建数据--></#comment>
    <#if !view.isEnableNewData()>

    /**
     * 是否启用新建数据
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isEnableNewData = function() {
        return false;
    }
    </#if>
    <#comment><!--结束：是否启用新建数据--></#comment>
    <#comment><!--开始：是否启用编辑数据--></#comment>
    <#if !view.isEnableEditData()>

    /**
     * 是否启用编辑数据
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isEnableEditData = function() {
        return false;
    }
    </#if>
    <#comment><!--结束：是否启用编辑数据--></#comment>
    <#comment><!--开始：是否启用删除数据--></#comment>
    <#if !view.isEnableRemoveData()>

    /**
     * 是否启用删除数据
     * 
     * @returns {boolean} 
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.isEnableRemoveData = function() { 
        return false;
    }
    </#if>
    <#comment><!--结束：是否启用删除数据--></#comment>
    <#comment><!--开始：打印常规数据--></#comment>
    <#if (view.isEnablePrint())>

    /**
     * 打印常规数据
     * 
     * @param {*} [arg={}] 
     * @returns {*} [arg={}]
     * @memberof ${view.codeName}ControllerBase
     */
    ${view.codeName}ControllerBase.prototype.getPrintDataView = function(arg) {
        <#if view.getPSDEPrint()??>
        if(true){
            Object.assign(arg , { srfprintid: '${view.getPSDEPrint().id}' });
            var view = {viewparam:arg};
            return view;
        }
        <#else>
        return undefined;
        </#if>
    }
    </#if>
    <#comment><!--结束：打印常规数据--></#comment>